#!C:\z-cassbeth\perl-5.30.1.1\perl\bin\perl.exe



##!"C:\xampp\perl\bin\perl.exe"
##!C:\z-cassbeth\perl-5.8.6\bin\perl.exe
##!C:\z-cassbeth\perl-5.30.1.1\perl\bin\perl.exe

##! perl
##!/usr/bin/perl -w

######################################################################
# Name:    nmt.cgi              
# Author:  Walter Sobkiw              
# Created: 03/20/00                   Last Modified:
# Archive: 
######################################################################
# Copyright 1999 Walter Sobkiw.  All Rights Reserved.
# By using this program you agree to indemnify Walter Sobkiw and 
# cassbeth from any liability.
#
# Selling the code for this program without prior written consent is
# expressly forbidden.  Obtain permission before redistributing this
# program over the Internet or in any other medium.  In all cases
# copyright and header must remain intact.

$version = "1.8";

# 1.8 03/16/2020
# added isolated failures color & moved to table format
# added perl protocol return to ensure correct protocol is processed
# corrected midnight rollover issues

# 1.7 03/14/2020
# updated new midnight status file to show heading and color
# changed default trigger C from 60 to 20
# changed default ping rate from 3 to 1
# changed loop from 10 to 30

# 1.6 03/12/2020
# reorganized control menu
# changed trigger counts to count total time out when failed
# changed trigger counts to count max min out when failed

# 1.4 03/12/2020
# added dos ping
# added perl ping type selections
# cleaned up color selection selection guide
# changed trigger counts to count total time out when failed

# 1.3 03/11/2020
# added run instructions
# cleaded up trigger counts to count total time out when failed

# 1.2 03/10/2020
# expanded intro, added help, 
# added color guide, 
# labeled triggers A-D, 
# added color for total failure D

# 1.1 03/09/2020
# 1.0 cassbeth reuse release 03/09/2020
# 0.1 cassbeth framework release 3/20/2000

######################################################################

$username = $ENV{'SERVER_NAME'};

$script = $ENV{'SCRIPT_NAME'};
$script =~ s/(.*)\/(.*)$/$2/;
$product = $1;

$url = "$ENV{'HTTP_REFERER'}";
$url =~ s/(.*)(~...)(.*)/http:\/\/localhost:4444\/$2/;

if (!$script) {$script = "nmt.cgi";}
if (!$url)    {$url = "http://localhost:4444$product";}

$script = "$url/$script";

if ($url =~ /nmt/) {$tui = "NMT"; $toolname = "Network Monitoring Tool";}


####################

use CGI::Carp qw(fatalsToBrowser);

print "Content-type: text/html\n\n";

# Retrieve Date
&get_date;
$starttime = "$hour:$min:$sec";
$startsec = $hour*3600+$min*60+$sec;

# Parse Form
&parse_form;

if ($FORM{'stopnow'}) {&stopnow;}
if ($FORM{'shutdown'}) {&shutdown;}

#print "script $script<P>";

# print html start
&html_start;

print "<TABLE><TR VALIGN='TOP'><TD>\n";
print " A funny thing happened on the way to the 21st century packet switched communications that we know as the Internet. 
It is extremely resilient in the presence of a failure. 
However it is also susceptible to massive unintended consequences because of its ability to be reconfigured instantly. 
As a result your service may degrade when least expected. 
This may be fine for a traditional management information system like banking, e-commerce, or a video streaming service with a 30 second buffer, 
but it is unacceptable for real time systems that must have messages appear at a destination within a specific time or the system will fail. 
These real time systems are found in process and command and control applications. 
The problems surface when these command and control systems detect the network dropout but the service providers claim all is fine. 
However all is not fine. 
This is a finger pointing exercise and only a third party simple network monitoring tool can help to resolve the conflict.
<P>
NMT lets you monitor the state of your network by keeping it very simple and pinging a remote host. 
You decide on the monitoring criteria. 
When the criteria is not met the ping event is logged. 
You decide on the criticality of the events by using different colors. 
All ping events are logged and accessible via a link. 
The current event status is maintained and accessible via a link. 
You can run multiple instances of NMT to ping multiple commutations paths in the system. 
Remember, just because you can ping a host it does not mean the host is up and running. 
This checks the communications connection to the host over long periods of time like overnight. 
It is simple and easy to use so that anyone can monitor their network and detect if it winks out for a few seconds. 
<P>
Use the control panel to make your settings and start NMT. 
<P>
<OL>
  <LI>
    Press the submit button to capture the settings. 
  <LI>
    Once settings are reasonable begin a small ping session. 
  <LI>
    When the settings are mature increase the session count to run overnight.
  <LI>
    Review the screen and logs the next morning. 
  <LI>
    Uncheck the ping run options and press the submit button. 
  <LI>
    Save this off as a new template in the NMT template folder.
</OL>
<P>
There are 2 ways to ping using NMT. The first and preferred method is to
use the Perl ping. This uses a Perl library with various options to ping
the remote destination. In this case the TCP option is the most reasonable.
It also takes the longest time because the remote uses its echo port to respond.
The second approach is to use the DOS ping.
<P>
You may be wondering why use NMT if you can just ping from a DOS window.
This tool provides structure, offers reasonable options, and saves off the
results automatically in common areas. It also uses colors to help visualize
the results. It may not seem like much until you need to run this 24/7 to
make sure your links are not winking out for a few seconds.
<P>
The biggest difference between the Perl TCP and DOS ICMP ping is the time.
That time difference might actually be the reason your real time system is
having problems but everyone else is claiming the network is fine, after
all the ICMP ping shows no evidence of a problem. With the new insights from
NMT there may be other evidence that suggest a network problem.
<P>";

print "</TD>";
print "<TD><CENTER><A HREF='http://www.cassbeth.com/book/index.html' TARGET='_blank'><IMG SRC='b1.jpg' BORDER='0' ALT='Sustainable Development Possible with Creative System Engineering buy from amazon.com'><BR>Book Information</A></CENTER></TD>";
print "</TR></TABLE>\n";
print "<P>";

&control_menu;

# requests
if ($FORM{'netstat'}) {&netstat;}
if ($FORM{'trace'}) {&trace;}
if ($FORM{'pingdos'}) {&pingdos;}
if ( ($FORM{'ping'}) || ($FORM{'traceloop'}) ){&ping;}

print "<P>version: $version</BODY></HTML>\n";

####################
sub html_start {

print <<END_HTMLSTART;
<HTML>
<HEAD>
<TITLE>$FORM{'name'}</TITLE>
</HEAD>
<BODY>
<TABLE CELLPADDING="2">
<TR VALIGN="TOP">
<TD><A HREF="$script"><IMG WIDTH="172" HEIGHT="59" SRC="cassbeth.gif" ALT="If this is a template Press Submit first" BORDER="0"></A></TD>
<TD><H2><FONT COLOR='GREEN'>$toolname</FONT></H2></TD>
<TD><FONT COLOR='RED'>$demo</FONT></TD>
<TD><SMALL>
<A HREF='status' TARGET='lib'>Status</A><BR>
<A HREF='logs' TARGET='log'>Logs</A><BR>
<A HREF='templates' TARGET='template'>Templates</A><BR>
<BR>
</SMALL></TD>
<TD> </TD>
<TD><SMALL>
<A HREF='help.html' TARGET='HELP'>Help</A><BR>
<A HREF='regex.html' TARGET='HELP'>REs</A><BR>
<A HREF='demo-reports' TARGET='lib'>Training</A><BR>
</SMALL></TD>
</TR>
</TABLE>
END_HTMLSTART

}

####################
sub html_start_1 {

print <<END_HTMLSTART;
<HTML>
<HEAD>
<TITLE>$FORM{'name'}</TITLE>
</HEAD>
<BODY>
<TABLE CELLPADDING="2">
<TR VALIGN="TOP">
<TD><A HREF="$script"><IMG WIDTH="172" HEIGHT="59" SRC="cassbeth.gif" ALT="If this is a template Press Submit first" BORDER="0"></A></TD>
<TD><H2><FONT COLOR='GREEN'>$toolname</FONT></H2></TD>
<TD><FONT COLOR='RED'>$demo</FONT></TD>
<TD><SMALL>
<A HREF='../status' TARGET='lib'>Status</A><BR>
<A HREF='../logs' TARGET='log'>Logs</A><BR>
<A HREF='../templates' TARGET='template'>Templates</A><BR>
<BR>
</SMALL></TD>
<TD> </TD>
<TD><SMALL>
<A HREF='../help.html' TARGET='HELP'>Help</A><BR>
<A HREF='../regex.html' TARGET='HELP'>REs</A><BR>
<A HREF='../demo-reports' TARGET='lib'>Training</A><BR>
</SMALL></TD>
</TR>
</TABLE>
<P>
<TABLE>
END_HTMLSTART

}

####################
sub parse_form {

#print "parse form<BR>\n";

   if ($ENV{'REQUEST_METHOD'} eq 'GET') {
      # Split the name-value pairs
      @pairs = split(/&/, $ENV{'QUERY_STRING'});
   }
   if ($ENV{'REQUEST_METHOD'} eq 'POST') {
      # Get the input
      read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
 
      # Split the name-value pairs
      @pairs = split(/&/, $buffer);
   }
   foreach $pair (@pairs) {
      ($name, $value) = split(/=/, $pair);
 
      $name =~ tr/+/ /;
      $name =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;

      $value =~ tr/+/ /;
      $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;

      $value =~ s/<!--(.|\n)*-->//g;

      $FORM{$name} .= " $value";
   }

#$request =~ s/\n|\r/ /g;
#$request =~ s/\s\s+/ /g;

}

####################
sub get_date {

($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);

$month = ($mon + 1);

if ($sec  < 10) {$sec  = "0$sec";}
if ($min  < 10) {$min  = "0$min";}
if ($hour < 10) {$hour = "0$hour";}
if ($month  < 10) {$month  = "0$month";}
if ($mday < 10) {$mday = "0$mday";}

$year = $year - 100;
$year = $year+2000;

$date = "$month/$mday/$year $hour\:$min\:$sec";

}

####################
sub control_menu {

if (!$FORM{'name'}) {$FORM{'name'} = "My-Analysis";}
if (!$FORM{'host'}) {$FORM{'host'} = "www.google.com";}
if (!$FORM{'samples'}) {$FORM{'samples'} = 30;}
if (!$FORM{'timeout'}) {$FORM{'timeout'} = .025;}
if (!$FORM{'rate'}) {$FORM{'rate'} = 1;}

if (!$FORM{'t1'}) {$FORM{'t1'} = 5;}
if (!$FORM{'t2'}) {$FORM{'t2'} = 10;}
if (!$FORM{'t3'}) {$FORM{'t3'} = 20;}

if (!$FORM{'c0'}) {$FORM{'c0'} = "aqua";}
if (!$FORM{'c1'}) {$FORM{'c1'} = "yellow";}
if (!$FORM{'c2'}) {$FORM{'c2'} = "orange";}
if (!$FORM{'c3'}) {$FORM{'c3'} = "fuchsia";}
if (!$FORM{'c4'}) {$FORM{'c4'} = "red";}

if (!$FORM{'bytes'}) {$FORM{'bytes'} = 1;}
if (!$FORM{'pnum'}) {$FORM{'pnum'} = 80;}
if (!$FORM{'traceh'}) {$FORM{'traceh'} = 30;}

if (!$FORM{'proto'}) {$FORM{'proto'} = "tcp"};
if ($FORM{'proto'} eq "default") {$state_default = "CHECKED"};
if ($FORM{'proto'} eq "tcp") {$state_tcp = "CHECKED"};
if ($FORM{'proto'} eq "udp") {$state_udp = "CHECKED"};
if ($FORM{'proto'} eq "stream") {$state_stream = "CHECKED"};
if ($FORM{'proto'} eq "external") {$state_external = "CHECKED"};
if ($FORM{'proto'} eq "icmp") {$state_icmp = "CHECKED"};
if ($FORM{'proto'} eq "dosping") {$state_dosping = "CHECKED"};


print "<HR><CENTER><H3>Settings</H3></CENTER><P>\n";

print "<FORM ACTION='http://localhost:4444/~nmt/nmt.cgi' METHOD='POST'>\n";

print "<INPUT TYPE='text' NAME='name' VALUE='$FORM{'name'}' SIZE='20'> Name Analysis File<BR>\n";
print "<INPUT TYPE='text' NAME='host' VALUE='$FORM{'host'}' SIZE='20'> Host<BR>\n";
print "<INPUT TYPE='text' NAME='samples' VALUE='$FORM{'samples'}' SIZE='10'> Samples (apache server timeout is 3,600,000 sec in conf file)<P>\n";
print "<INPUT TYPE='text' NAME='timeout' VALUE='$FORM{'timeout'}' SIZE='5'> Ping timeout seconds (.2, .5, 1, 2, etc) <BR>\n";
print "<INPUT TYPE='text' NAME='rate' VALUE='$FORM{'rate'}' SIZE='5'> Ping rate in seconds (1, 2, 5, etc) \n";
print "<INPUT TYPE='checkbox' NAME='randomize' VALUE='CHECKED' $FORM{'randomize'}> Randomize (0 to the set value)<P>\n";
print "<P>";
print "Quick checks: ";
print "<INPUT TYPE='checkbox' NAME='trace' VALUE='CHECKED' $FORM{'trace'}> Trace Once\n";
print "<INPUT TYPE='text' NAME='traceh' VALUE='$FORM{'traceh'}' SIZE='3'>  Hops\n";
print "<INPUT TYPE='checkbox' NAME='netstat' VALUE='CHECKED' $FORM{'netstat'}> Netstat \n";
print "<INPUT TYPE='checkbox' NAME='pingdos' VALUE='CHECKED' $FORM{'pingdos'}> Ping DOS\n";
print "<INPUT TYPE='text' NAME='pingdosopt' VALUE='$FORM{'pingdosopt'}' SIZE='10'>  Options (-l size bytes)\n";
print "<P>";
print "Timeout Criteria:<BR>
<TABLE>
<TR>
<TD BGCOLOR='Black'><FONT COLOR='WHITE'>BLACK</FONT></TD> 
<TD BGCOLOR='White'>WHITE</TD> 
<TD BGCOLOR='Red'>RED</TD> 
<TD BGCOLOR='Green'>GREEN</TD> 
<TD BGCOLOR='Blue'>BLUE</TD> 
<TD BGCOLOR='Yellow'>YELLOW</TD>. 
<TD BGCOLOR='Gray'>GRAY</TD> 
<TD BGCOLOR='Maroon'>MARRON</TD> 
<TD BGCOLOR='Olive'>OLIVE</TD> 
<TD BGCOLOR='Navy'>NAVY</TD> 
<TD BGCOLOR='Purple'>PURPLE</TD> 
<TD BGCOLOR='Lime'>LIME</TD> 
<TD BGCOLOR='Aqua'>AQUA</TD>
<TD BGCOLOR='Teal'>TEAL</TD> 
<TD BGCOLOR='Orange'>ORANGE</TD> 
<TD BGCOLOR='Fuchsia'>FUCHIA</TD> 
<TD BGCOLOR='Silver'>SILVER</TD> 
</TR>
</TABLE>
<P>";

print "<TABLE BORDER='0'>
<TR>
<TD BGCOLOR='$FORM{'c0'}'>-</TD>
<TD>-</TD>
<TD>Isolated Failure Event</TD>
<TD><INPUT TYPE='text' NAME='c0' VALUE='$FORM{'c0'}' SIZE='10'> Color</TD>
</TR>

<TR>
<TD BGCOLOR='$FORM{'c1'}'>A</TD>
<TD><INPUT TYPE='text' NAME='t1' VALUE='$FORM{'t1'}' SIZE='5'></TD>
<TD>Consecutive Failures Criteria</TD>
<TD><INPUT TYPE='text' NAME='c1' VALUE='$FORM{'c1'}' SIZE='10'> Color</TD>
</TR>

<TR>
<TD BGCOLOR='$FORM{'c2'}'>B</TD>
<TD><INPUT TYPE='text' NAME='t2' VALUE='$FORM{'t2'}' SIZE='5'></TD>
<TD>Consecutive Failures Criteria</TD>
<TD><INPUT TYPE='text' NAME='c2' VALUE='$FORM{'c2'}' SIZE='10'> Color</TD>
</TR>

<TR>
<TD BGCOLOR='$FORM{'c3'}'>C</TD>
<TD><INPUT TYPE='text' NAME='t3' VALUE='$FORM{'t3'}' SIZE='5'></TD>
<TD>Consecutive Failures Criteria</TD>
<TD><INPUT TYPE='text' NAME='c3' VALUE='$FORM{'c3'}' SIZE='10'> Color</TD>
</TR>

<TR>
<TD BGCOLOR='$FORM{'c4'}'>D</TD>
<TD>-</TD>
<TD>Possible Comm System Failure</TD>
<TD><INPUT TYPE='text' NAME='c4' VALUE='$FORM{'c4'}' SIZE='10'> Color</TD>
</TR>

</TABLE>
<P>";

print "Ping Type:<P>";
print "DOS <INPUT TYPE='radio' NAME='proto' VALUE='dosping' $state_dosping> ICMP (doswin goes up/dwn no port)<P>\n";
print "Perl ";
print "<INPUT TYPE='radio' NAME='proto' VALUE='default' $state_default> Default\n";
print "<INPUT TYPE='radio' NAME='proto' VALUE='tcp' $state_tcp> TCP default\n";
print "<INPUT TYPE='radio' NAME='proto' VALUE='udp' $state_udp> UDP\n";
print "<INPUT TYPE='text' NAME='bytes' VALUE='$FORM{'bytes'}' SIZE='5'> UDP Bytes";
print "<INPUT TYPE='radio' NAME='proto' VALUE='stream' $state_stream> Stream\n";
print "<INPUT TYPE='radio' NAME='proto' VALUE='external' $state_external> External\n";
print "<INPUT TYPE='radio' NAME='proto' VALUE='icmp' $state_icmp> ICMP (UNIX root)\n";
print "<INPUT TYPE='checkbox' NAME='port' VALUE='CHECKED' $FORM{'port'}> Port \n";
print "<INPUT TYPE='text' NAME='pnum' VALUE='$FORM{'pnum'}' SIZE='5'> \n";
print "<P>";
print "Select to run:<P>";
print "<INPUT TYPE='checkbox' NAME='ping' VALUE='CHECKED' $FORM{'ping'}> Ping Loop\n";
print "<INPUT TYPE='checkbox' NAME='traceloop' VALUE='CHECKED' $FORM{'traceloop'}> Trace Loop\n";
print "<P>";
print "<INPUT TYPE='checkbox' NAME='show' VALUE='CHECKED' $FORM{'show'}> Show Live Data Here\n";

print "<P>";
print "<INPUT TYPE='submit' VALUE='Submit'> ";
print "<INPUT TYPE='submit' NAME='shutdown' VALUE='Exit'> &nbsp; &nbsp; &nbsp; ";
print "<A HREF='nmt.cgi?stopnow=$$' TARGET='stopnow'>Stop Now</A> ";

print "</FORM>\n";

}

####################
sub pingdos {

$|=1;
#$pingdos = `ping -n $FORM{'samples'} $FORM{'host'}`;
#print "START<BR><PRE>$pingdos</PRE><BR>DONE<P>";
print "START<BR><PRE>";
exec ("ping -n $FORM{'samples'} $FORM{'pingdosopt'} $FORM{'host'}");
print "</PRE><BR>DONE<P>";

#$cmd = "tracert $FORM{'host'}";
#print "START<BR><PRE>";
#exec ($cmd);
#print "</PRE><BR>DONE";

}

####################
sub trace {

$trace = `tracert -h $FORM{'pingdosopt'} $FORM{'traceh'} $FORM{'host'}`;
print "START<BR><PRE>$trace</PRE><BR>DONE<P>";

#$cmd = "tracert $FORM{'host'}";
#print "START<BR><PRE>";
#exec ($cmd);
#print "</PRE><BR>DONE";

}

####################
sub netstat {

$netstat = `netstat`;
print "START<BR><Pre>$netstat</Pre><BR>DONE<P>";

#$cmd = "netstat";
#print "START<BR><PRE>";
#exec ($cmd);
#print "</PRE><BR>DONE";

}

####################
sub ping {

#use strict;
#my $r = Apache->request;  
#$r->rflush;

$| = 1;

&get_date;
$starttime = "$hour:$min:$sec";
$starttime1 = "$hour$min$sec";
$startsec = $hour*3600+$min*60+$sec;

$filesname = "$month-$mday-$year-$starttime1";

print "<H2>Network Monitoring Started</H2>";

print "$starttime Start Time<BR>";

use Net::Ping;

# enable high-resolution timers
#$net->hires( );

# Host can be either an IP or domain name
my $host = $FORM{'host'};

#optionally specify a timeout in seconds (Defaults to 5 if not set)
$timeout = $FORM{'timeout'};

print "$host $timeout<BR>";

# Create a new ping object
#item Net::Ping->new([proto, timeout, bytes, device, tos, ttl, family,

#                     host, port, bind, gateway, retrans, pingstring,

#                     source_verify econnrefused dontfrag

#                     IPV6_USE_MIN_MTU IPV6_RECVPATHMTU])

#my $p = Net::Ping->new(udp); #tcp is default

# icmp needs root priv
if ($FORM{'proto'} =~ /default/)  {$p = Net::Ping->new(); print "$FORM{'proto'}<BR>";}
if ($FORM{'proto'} =~ /tcp/)  {$p = Net::Ping->new(tcp); print "$FORM{'proto'}<BR>";}
if ($FORM{'proto'} =~ /udp/)  {$p = Net::Ping->new(udp, $timeout, $FORM{'bytes'});  
   print "$FORM{'proto'} bytes: $FORM{'bytes'} recommended: 1472 (Ethernet MTU: 1500) Max: 65535<BR>";
}
if ($FORM{'proto'} =~ /stream/) {$p = Net::Ping->new(stream); print "$FORM{'proto'}<BR>";}
if ($FORM{'proto'} =~ /external/) {$p = Net::Ping->new(external); print "$FORM{'proto'}<BR>";}
if ($FORM{'proto'} =~ /icmp/) {$p = Net::Ping->new(icmp); print "$FORM{'proto'}<BR>";}
if ($FORM{'proto'} =~ /dosping/) {print "$FORM{'proto'}<BR>";}

# Optionally specify a port number (Defaults to echo port is not used)
if ( ($FORM{'port'}) && ($FORM{'proto'} !~ /dosping/) ){$p->port_number($FORM{'pnum'});}
print "port: $p->{port_num}<BR>";
print "<BR>";

if ($FORM{'proto'} !~ /dosping/) {
   $protortn = $p->{proto};
   print "Protocol return from Perl: $protortn<P>";
}

$totfail = 0;
$failt1 = 0;
$failt2 = 0;
$failt3 = 0;
$failt4 = 0;

print "<TABLE>";

for ($i = 1; $i <= $FORM{'samples'}; ++$i) {

if (!$FORM{'randomize'}) {sleep ( $FORM{'rate'} );}
if ($FORM{'randomize'}) {sleep( rand( $FORM{'rate'} ) );}

&get_date;
$starttime1 = "$hour$min$sec";

# print header at start and midnight rollover
if ($mday !~ /$mdayold/) {

   $filesname = "$month-$mday-$year-$starttime1";
   $mdayold = $mday;

   $file = "status/$FORM{'name'}-events-$filesname.html";
   open(STATUS, ">>$file") or print "unable to open logfile $file";
   binmode(STATUS);  # write files accurately
   select STATUS;
   &html_start_1;
   print "$starttime Start Time<BR>";
   print "$host $timeout<BR>";
   print "$FORM{'proto'}<BR>";
   print "port: $p->{port_num}<P>";
   select STDOUT;
   close(STATUS);

   $file = "status/$FORM{'name'}-report-$filesname.html";
   open(REPORT, ">>$file") or print "unable to open logfile $file";
   binmode(REPORT);  # write files accurately
   select REPORT;
   &html_start_1;
   print "$starttime Start Time<BR>";
   print "$host $timeout<BR>";
   print "$FORM{'proto'}<BR>";
   print "port: $p->{port_num}<P>";
   select STDOUT;
   close(REPORT);
}

close(LOG);
$file = "logs/$FORM{'name'}-$filesname.log";
open(LOG, ">>$file") or print "unable to open logfile $file";
binmode(LOG);  # write files accurately

close(STATUS);
$file = "status/$FORM{'name'}-events-$filesname.html";
open(STATUS, ">>$file") or print "unable to open logfile $file";
binmode(STATUS);  # write files accurately

close(REPORT);
$file = "status/$FORM{'name'}-report-$filesname.html";
open(REPORT, ">>$file") or print "unable to open logfile $file";
binmode(REPORT);  # write files accurately

&get_date;

$ret = 0;
$duration = 0;
$dosping = 0;

if ($state_dosping) {
   $dosping = "";
   $dosping = `ping -n 1 $FORM{'host'}`;
}
else {
   ($ret, $duration, $ip) = ($p->ping($host, $timeout));
   #$ret = "$ret $protortn";
}

# server found
if ( ($ret) || ($duration) || ($dosping =~ /reply from/i) ){

   $ret = "$ret $protortn";

   if ($dosping =~ /reply from (.*) time=(\d+)ms/i) {
      $ret = "1 dosping";
      $ip = "$1";
      $duration = $2/1000;
      if ($duration > $timeout) {++$fail; ++$fail1; ++$fail2; ++$fail3; ++$totfail; $ret = "0 dosping"; $color = $FORM{'c0'}}
      else {$fail = 0; $fail1 = 0; $fail2 = 0; $fail3 = 0; $color = "";}
   }
   else {
      #check timeout criteria count failures and reset count
      if ($ret =~ /0/) {++$fail; ++$fail1; ++$fail2; ++$fail3; ++$totfail; $color = $FORM{'c0'}}
      else {$fail = 0; $fail1 = 0; $fail2 = 0; $fail3 = 0; $color = "";}
   }

   # set colors
   if ($fail >= $FORM{'t1'}) {$color = $FORM{'c1'}};
   if ($fail >= $FORM{'t2'}) {$color = $FORM{'c2'}};
   if ($fail >= $FORM{'t3'}) {$color = $FORM{'c3'}};

   if ($fail1 >= $FORM{'t1'}) {$fail1 = 0; ++$failt1;};
   if ($fail2 >= $FORM{'t2'}) {$fail2 = 0; ++$failt2;};
   if ($fail3 >= $FORM{'t3'}) {$fail3 = 0; ++$failt3;};

   #stats
   $tottime = $tottime + $duration;
   $avg = $tottime / $i;
   if ($i <= 1) {$maxdur = $duration; $mindur = $duration;}
   if ($duration > $maxdur) {$maxdur = $duration;}
   if ($duration < $mindur) {$mindur = $duration;}
   $fmindown = $maxdown;
   $downtime = 0;


   if ($FORM{'show'}) {
      print "<TR BGCOLOR = '$color'><TD>";
      printf ("$date $host ip: $ip alive timeout $timeout: $ret pkt rtn: %.3f sec . ", $duration);
      printf ("max: %.3f min: %.3f avg: %.3f fail A: $failt1 B: $failt2 C: $failt3 D: $failt4 totfail: $totfail no: $i<BR>\n", $maxdur, $mindur, $avg);
      print "</TD></TR>\n";
   }
   printf LOG ("$date $host ip: $ip alive timeout $timeout: $ret pkt rtn: %.3f sec . ", $duration);
   printf LOG ("max: %.3f min: %.3f avg: %.3f fail A: $failt1 B: $failt2 C: $failt3 D: $failt4 totfail: $totfail no: $i\n", $maxdur, $mindur, $avg);
   print REPORT "<TR BGCOLOR = '$color'><TD>";
   printf REPORT ("$date $host ip: $ip alive timeout $timeout: $ret pkt rtn: %.3f sec . ", $duration);
   printf REPORT ("max: %.3f min: %.3f avg: %.3f fail A: $failt1 B: $failt2 C: $failt3 D: $failt4 totfail: $totfail no: $i<BR>\n", $maxdur, $mindur, $avg);
   print "</TD></TR>\n";
}

# no server found
else {

   # count failures
   ++$fail; ++$fail1; ++$fail2; ++$fail3; ++$fail4; ++$totfail;

   # set colors
   $color = $FORM{'c4'};

   if ($fail1 >= $FORM{'t1'}) {$fail1 = 0; ++$failt1;};
   if ($fail2 >= $FORM{'t2'}) {$fail2 = 0; ++$failt2;};
   if ($fail3 >= $FORM{'t3'}) {$fail3 = 0; ++$failt3;};
   $failt4 = $fail4;

   #stats
   $downtime = $downtime + $FORM{'rate'};
   if ($downtime > $maxdown) {$maxdown = $downtime;}

   $tottime = $tottime + $FORM{'rate'};
   #$avg = $tottime / $i;
   #$maxdur = $FORM{'rate'};
   $mindur = $FORM{'rate'};

   if ($FORM{'show'}) {
      print "<TR BGCOLOR = '$color'><TD>";
      print "$date ALARM $FORM{'proto'}: ".$host." is down or comm is down or server blocked packets ";
      printf ("max: %.3f min: %.3f TotDwn: %.3f fail A: $failt1 B: $failt2 C: $failt3 D: $failt4 totfail: $totfail no: $i<BR>\n", $maxdown, $fmindown, $downtime);
      print "</TD></TR>\n";

   }
   print LOG "$date ALARM $FORM{'proto'}: ".$host." is down or comm is down or server blocked packets ";
   printf LOG ("max: %.3f min: %.3f TotDwn: %.3f fail A: $failt1 B: $failt2 C: $failt3 D: $failt4 totfail: $totfail no: $i<BR>\n", $maxdown, $fmindown, $downtime);

   print REPORT "<TR BGCOLOR = '$color'><TD>";
   print REPORT "$date ALARM $FORM{'proto'}: ".$host." is down or comm is down or server blocked packets ";
   printf REPORT ("max: %.3f min: %.3f TotDwn: %.3f fail A: $failt1 B: $failt2 C: $failt3 D: $failt4 totfail: $totfail no: $i<BR>\n", $maxdown, $fmindown, $downtime);

   print "</TD></TR>\n";
   print REPORT "</TD></TR>\n";
   $hostdown = 1;
}

# print to status page
if ( ($fail >= $FORM{'t1'}) || ($color) ) {
   if (!$hostdown) {
      print STATUS "<TR BGCOLOR = '$color'><TD>";
      printf STATUS ("$date $host ip: $ip alive timeout $timeout: $ret pkt rtn: %.3f sec . ", $duration);
      printf STATUS ("max: %.3f min: %.3f avg: %.3f fail A: $failt1 B: $failt2 C: $failt3 D: $failt4 totfail: $totfail no: $i<BR>\n", $maxdur, $mindur, $avg);
   }
   if ($hostdown) {
      print STATUS "<TR BGCOLOR = '$color'><TD>";
      print STATUS "$date ALARM $FORM{'proto'}: ".$host." is down or comm is down or server blocked packets ";
      printf STATUS ("max: %.3f min: %.3f TotDwn: %.3f fail A: $failt1 B: $failt2 C: $failt3 D: $failt4 totfail: $totfail no: $i<BR>\n", $maxdown, $mindown, $downtime);
   }
   print STATUS "</TD></TR>\n";
   $hostdown = 0;
}

# trace in the loop
if ($FORM{'traceloop'}) {
   $trace = `tracert $FORM{'host'}`;
   print "<PRE>$trace</PRE>\n";
   print LOG "$trace\n";
}

}

print "</TABLE>";

&get_date;
$endtime = "$hour:$min:$sec";
$endsec = $hour*3600+$min*60+$sec;
$sec = $endsec - $startsec;
print "<P>$endtime End Time<BR>$sec Seconds";

# close our ping handle
if ($FORM{'proto'} !~ /dosping/) {
   print "<P>Perl ping port closed<P>";
   $p->close();
}

}

####################
sub stopnow {

$status = kill 9, $FORM{'stopnow'};
print "Stopping Network Monitoring $FORM{'stopnow'} $status<P>\n";

&get_date;
$endtime = "$hour:$min:$sec";
$endsec = $hour*3600+$min*60+$sec;
$sec = $endsec - $startsec;

print "
$starttime Start Time<BR>
$endtime End Time<BR>
$sec Seconds<P>";

print "Close this window<BR><BR><BR><BR><BR>\n";

print "<HR>";

exit;

}

####################
sub shutdown {

if ($FORM{shutdown} !~ /apache/) {
   print "Thank You.<P>
   Please <A HREF='$script?shutdown=apache'>SELECT here to Stop the Web server</A>,<P>THEN close this browser window.";
}

if ($FORM{shutdown} =~ /apache/) {

# httpd pid
$file = "../apache/logs/httpd.pid";
open(SA,"$file");
$pida = <SA>;
close(SA);
$status = unlink $file;
print "Apache Started with PID: $pida $file $status<BR>";
$status = kill 9, $pida;
print "Stopping Apache $pida $status<P>\n";

# error pid
$file = "../apache/logs/error.log";
open(SA,"$file");
@pidc = <SA>;
close(SA);
$pidc = $pidc[$#pidc];
if ($pidc =~ /Child\s*(-?\d+)/i) {$pidc = $1;}
$status = unlink $file;

print "Apache Started with Child PID: $pidc $status $file<BR>";
$status = kill 9, $pidc;
print "Stopping Apache Child $pidc $status<P>\n";

#print "Please close your Browser Now ... Bye\n";

# httpd pid
$file = "../apache/logs/httpd.pid";
open(SA,"$file");
$pida = <SA>;
close(SA);
$status = unlink $file;

print "Apache Started with PID: $pida $status $file<BR>";
$status = kill 9, $pida;
print "Stopping Apache $pida $status<P>\n";

print "You can now close your browser.<P>";

$| = 1;

}

exit;

}

####################
sub parse_form {


 if ($ENV{'REQUEST_METHOD'} eq 'GET') {
    # Split the name-value pairs
    @pairs = split(/&/, $ENV{'QUERY_STRING'});
 }
 elsif ($ENV{'REQUEST_METHOD'} eq 'POST') {
    # Get the input
    read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
 
    # Split the name-value pairs
    @pairs = split(/&/, $buffer);
 }

 foreach $pair (@pairs){
    ($name,$value) = split(/=/,$pair);

    $name =~ tr/+/ /;
    $name =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;

    $value =~ tr/+/ /;
    $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;

    # If they try to include server side includes, erase them, so they
    # arent a security risk if the html gets returned.  Another 
    # security hole plugged up.

    $value =~ s/<!--(.|\n)*-->//g;

    $FORM{$name} = $value;
 }

}
